000100050322     /*                                                                       +
000101050322      *  svngetifs.rpgle: Get mtime of IFS file                               +
000102050318      *                                                                       +
000103050318      * ====================================================================  +
000104050318      * Copyright (c) 2000-2005 CollabNet.  All rights reserved.              +
000105050318      *                                                                       +
000106050318      * This software is licensed as described in the file COPYING, which     +
000107050318      * you should have received as part of this distribution.  The terms     +
000108050318      * are also available at http://subversion.tigris.org/license-1.html.    +
000109050318      * If newer versions of this license are posted there, you may use a     +
000110050318      * newer version instead, at your option.                                +
000111050318      *                                                                       +
000112050318      * This software consists of voluntary contributions made by many        +
000113050318      * individuals.  For exact contribution history, see the revision        +
000114050318      * history and logs, available at http://subversion.tigris.org/.         +
000115050318      * ====================================================================  +
000116050318      */
000117050318     H COPYRIGHT('Copyright (c) 2000-2005 CollabNet.  All rights reserved.')
000118050318     H DFTACTGRP(*NO) ACTGRP(*CALLER)
000119050316     D**********************************************************************
000120050316     D* File Information Structure (stat)
000121050316     D*
000122050316     D* struct stat {
000123050316     D*  mode_t         st_mode;       /* File mode                       */
000124050316     D*  ino_t          st_ino;        /* File serial number              */
000125050316     D*  nlink_t        st_nlink;      /* Number of links                 */
000126050316     D*  uid_t          st_uid;        /* User ID of the owner of file    */
000127050316     D*  gid_t          st_gid;        /* Group ID of the group of file   */
000128050316     D*  off_t          st_size;       /* For regular files, the file
000129050316     D*                                 * size in bytes                   */
000130050316     D*  time_t         st_atime;      /* Time of last access             */
000131050316     D*  time_t         st_mtime;      /* Time of last data modification  */
000132050316     D*  time_t         st_ctime;      /* Time of last file status change */
000133050316     D*  dev_t          st_dev;        /* ID of device containing file    */
000134050316     D*  size_t         st_blksize;    /* Size of a block of the file     */
000135050316     D*  unsigned long  st_allocsize;  /* Allocation size of the file     */
000136050316     D*  qp0l_objtype_t st_objtype;    /* AS/400 object type              */
000137050316     D*  unsigned short st_codepage;   /* Object data codepage            */
000138050316     D*  char           st_reserved1[66]; /* Reserved                     */
000139050316     D* };
000140050316     D*
000141050316     D p_statds        S               *
000142050316     D statds          DS                  BASED(p_statds)
000143050316     D  st_mode                      10U 0
000144050316     D  st_ino                       10U 0
000145050316     D  st_nlink                      5U 0
000146050316     D  st_pad                        2A
000147050316     D  st_uid                       10U 0
000148050316     D  st_gid                       10U 0
000149050316     D  st_size                      10I 0
000150050316     D  st_atime                     10I 0
000151050316     D  st_mtime                     10I 0
000152050316     D  st_ctime                     10I 0
000153050316     D  st_dev                       10U 0
000154050316     D  st_blksize                   10U 0
000155050316     D  st_alctize                   10U 0
000156050316     D  st_objtype                   12A
000157050316     D  st_codepag                    5U 0
000158050316     D  st_resv11                    62A
000159050316     D  st_ino_gen_id                10U 0
000160050316
000161050316     D*--------------------------------------------------------------------
000162050316     D* Get File Information
000163050316     D*
000164050316     D* int stat(const char *path, struct stat *buf)
000165050316     D*--------------------------------------------------------------------
000166050316     D stat            PR            10I 0 ExtProc('stat')
000167050316     D   path                          *   value options(*string)
000168050316     D   buf                           *   value
000169050316
000170050316     D GetTimeZone     PR             5A
000171050316
000172050316     D timezone        DS
000173050316     D   tzDir                        1A
000174050316     D   tzHour                       2S 0
000175050316     D   tzFrac                       2S 0
000176050316
000177050316
000178050316     D statsize        S             10I 0
000179050316     d Filename        S           2000A
000180050316     d Error           S              1A
000181050316     D ModifyTime      S               Z
000182050316     D Epoch           S               Z   INZ(z'1970-01-01-00.00.00')
000183050316
000184050316     c     *Entry        Plist
000185050316     c                   Parm                    Filename
000186050316     c                   Parm                    ModifyTime
000187050316     c                   Parm                    Error
000188050316
000189050316
000190050316     c                   eval      Error = 'N'
000191050316     c                   eval      statsize = %size(statds)
000192050316     c                   alloc     statsize      p_statds
000193050316
000194050316     c                   if        stat(%Trimr(Filename):
000195050316     c                             p_statds) < 0
000196050316     c                   eval      Error = 'Y'
000197050316     c                   dealloc                 p_statds
000198050316     c                   eval      *inlr = *on
000199050316     c                   return
000200050316     c                   endif
000201050316
000202050316      ** times in statds are seconds from the "epoch" (Jan 1, 1970)
000203050316      **   and are in GMT (Greenwich Mean Time)...
000204050316      ** Hey!  Lets convert them to RPG timestamps!
000205050316     c     Epoch         adddur    st_mtime:*S   ModifyTime
000206050316
000207050316      ** adjust timestamps for timezone:
000208050316     c                   eval      timezone = GetTimeZone
000209050316     c                   if        tzDir = '-'
000210050316     c                   subdur    tzHour:*H     ModifyTime
000211050316     c                   else
000212050316     c                   adddur    tzHour:*H     ModifyTime
000213050316     c                   endif
000218050316
000219050316     c                   dealloc                 p_statds
000220050316     c                   eval      *inlr = *on
000221050316
000222050316
000223050316     P*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000224050316     P*  This gets the offset from Universal Coordinated Time (UTC)
000225050316     P*    from the system value QUTCOFFSET
000226050316     P*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
000227050316     P GetTimeZone     B
000228050316     D GetTimeZone     PI             5A
000229050316     D peRcvVar        S              1A   DIM(100)
000230050316     D peRVarLen       S             10I 0
000231050316     D peNumVals       S             10I 0
000232050316     D peSysValNm      S             10A
000233050316     D p_Offset        S               *
000234050316     D wkOffset        S             10I 0 BASED(p_Offset)
000235050316     D p_SV            S               *
000236050316     D dsSV            ds                  BASED(p_SV)
000237050316     D   dsSVSysVal                  10A
000238050316     D   dsSVDtaTyp                   1A
000239050316     D   dsSVDtaSts                   1A
000240050316     D   dsSVDtaLen                  10I 0
000241050316     D   dsSVData                     5A
000242050316     D dsErrCode       DS
000243050316     D  dsBytesPrv             1      4B 0 INZ(256)
000244050316     D  dsBytesAvl             5      8B 0 INZ(0)
000245050316     D  dsExcpID               9     15
000246050316     D  dsReserved            16     16
000247050316     D  dsExcpData            17    256
000248050316     C                   CALL      'QWCRSVAL'                           99
000249050316     C                   PARM                    peRcvVar
000250050316     C                   PARM      100           peRVarLen
000251050316     c                   PARM      1             peNumVals
000252050316     c                   PARM      'QUTCOFFSET'  peSysValNm
000253050316     c                   PARM                    dsErrCode
000254050316     c                   if        dsBytesAvl > 0  or  *IN99 = *On
000255050316     c                   return    *blanks
000256050316     c                   endif
000257050316     c                   eval      p_Offset = %addr(peRcvVar(5))
000258050316     c                   eval      p_SV = %addr(peRcvVar(wkOffset+1))
000259050316     c                   return    dsSVData
000260050316     P                 E
