000100050322     /*                                                                       +
000101050322      *  svngetobj.rpgle: Get creation time of iSeries object                 +
000102050318      *                                                                       +
000103050318      * ====================================================================  +
000104050318      * Copyright (c) 2000-2005 CollabNet.  All rights reserved.              +
000105050318      *                                                                       +
000106050318      * This software is licensed as described in the file COPYING, which     +
000107050318      * you should have received as part of this distribution.  The terms     +
000108050318      * are also available at http://subversion.tigris.org/license-1.html.    +
000109050318      * If newer versions of this license are posted there, you may use a     +
000110050318      * newer version instead, at your option.                                +
000111050318      *                                                                       +
000112050318      * This software consists of voluntary contributions made by many        +
000113050318      * individuals.  For exact contribution history, see the revision        +
000114050318      * history and logs, available at http://subversion.tigris.org/.         +
000115050318      * ====================================================================  +
000116050318      */
000117050318     H COPYRIGHT('Copyright (c) 2000-2005 CollabNet.  All rights reserved.')
000118050318     H DFTACTGRP(*NO) ACTGRP(*CALLER)
000119050316     **-- Global variables:-------------------------------------------------**
000120050316     D ObjNam          s             10a
000121050316     D ObjLib          s             10a
000122050316     D ObjTyp          s             10a
000123050316     D CreateTime      s               z
000124050316     D TempDate        s               d
000125050316     D TempTime        s               t
000126050316     D Error           s              1a
000127050316     **-- Api error data structure:-----------------------------------------**
000128050316     D ApiError        Ds
000129050316     D  AeBytPro                     10i 0 Inz( %Size( ApiError ))
000130050316     D  AeBytAvl                     10i 0 Inz
000131050316     D  AeMsgId                       7a
000132050316     D                                1a
000133050316     D  AeMsgDta                    128a
000134050316     **-- Object description structure OBJD0100:----------------------------**
000135050316     D RoData          Ds
000136050316     D  RoBytRtn                     10i 0
000137050316     D  RoBytAvl                     10i 0
000138050316     D  RoObjNam                     10a
000139050316     D  RoObjLib                     10a
000140050316     D  RoObjTypRt                   10a
000141050316     D  RoObjLibRt                   10a
000142050316     D  RoObjASP                     10i 0
000143050316     D  RoObjOwn                     10a
000144050316     D  RoObjDmn                      2a
000145050316     D  RoObjCrtDts                  13a
000146050316     D    CrtDate                     7a   Overlay(RoObjCrtDts)
000147050316     D    CrtTime                     6a   Overlay(RoObjCrtDts:*NEXT)
000148050316     D  RoObjChgDts                  13a
000149050316     D  RoExtAtr                     10a
000150050316     D  RoTxtDsc                     50a
000151050316     D  RoSrcF                       10a
000152050316     D  RoSrcLib                     10a
000153050316     D  RoSrcMbr                     10a
000154050316     **-- Retrieve object description:--------------------------------------**
000155050316     D RtvObjD         Pr                  ExtPgm( 'QUSROBJD' )
000156050316     D  RoRcvVar                  32767a         Options( *VarSize )
000157050316     D  RoRcvVarLen                  10i 0 Const
000158050316     D  RoFmtNam                      8a   Const
000159050316     D  RoObjNamQ                    20a   Const
000160050316     D  RoObjTyp                     10a   Const
000161050316     D  RoError                   32767a         Options( *VarSize )
000162050316     **
000163050316     **
000164050316     C     *Entry        Plist
000165050316     C                   Parm                    ObjNam
000166050316     C                   Parm                    ObjLib
000167050316     C                   Parm                    ObjTyp
000168050316     C                   Parm                    CreateTime
000169050316     C                   Parm                    Error
000170050316     **
000171050316     C                   Eval      Error = 'N'
000172050316     C                   CallP     RtvObjD( RoData
000173050316     C                                    : %Size( RoData )
000174050316     C                                    : 'OBJD0100'
000175050316     C                                    : ObjNam + ObjLib
000176050316     C                                    : ObjTyp
000177050316     C                                    : ApiError
000178050316     C                                    )
000179050316     **
000180050316     C                   If        AeBytAvl   >  *Zero
000181050316     C                   If        %Subst(AeMsgId:1:5) = 'CPF98'
000182050316     **-- Object doesn't exist...
000183050316     **   CPF9801 E - Object &2 in library &3 not found.
000184050316     **   CPF9802 E - Not authorized to object &2 in &3.
000185050316     **   CPF9803 E - Cannot allocate object &2 in library &3.
000186050316     **   CPF9811 E - Program &2 in library &3 not found.
000187050316     C                   Eval      Error = 'Y'
000188050316     C                   Eval      *Inlr = *On
000189050316     C                   Return
000190050316     C                   EndIf
000191050316     C                   EndIf
000192050316     C     *CYMD0        MOVE      CrtDate       TempDate
000193050316     C     *HMS0         MOVE      CrtTime       TempTime
000194050316     C                   MOVE      TempDate      CreateTime
000195050316     C                   MOVE      TempTime      CreateTime
000196050316     C                   Eval      *Inlr = *On
